//+------------------------------------------------------------------+
//|                                           ChandelierStops_v1.mq4 |
//|                                  Copyright  2006, Forex-TSD.com |
//|                         Written by IgorAD,igorad2003@yahoo.co.uk |   
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |                                      
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Forex-TSD.com "
#property link      "http://www.forex-tsd.com/"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1  Blue
#property indicator_color2  Red

//
//
//
//
//

extern string  TimeFrame = "Current time frame";
extern int     Length    = 15;
extern int     ATRperiod = 14;
extern double  Kv        = 4;
extern int     Shift     = 1;

//
//
//
//
//

double Up[];
double Dn[];
double smin[];
double smax[];
double trend[];

//
//
//
//
//

string indicatorFileName;
int    timeFrame;
bool   returnBars;
bool   calculateValue;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{

   IndicatorBuffers(5);
   SetIndexBuffer(0,Up); SetIndexLabel(0,"Up");
   SetIndexBuffer(1,Dn); SetIndexLabel(1,"Dn");
   SetIndexBuffer(2,smin);
   SetIndexBuffer(3,smax);
   SetIndexBuffer(4,trend);
   
      //
      //
      // 
      //
      //
      
      indicatorFileName = WindowExpertName();
      calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
      returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
      timeFrame         = stringToTimeFrame(TimeFrame);
      
      //
      //
      //
      //
      //
       
      IndicatorShortName(timeFrameToString(timeFrame)+"  Chandelier Stops");
      return(0);
}
      
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { Up[0] = limit+1; return(0); }

   //
   //
   //
   //
   //

   if (calculateValue || timeFrame==Period())
   {
     for (i=limit; i>=0; i--)
     { 
        smin[i] = High[iHighest(NULL,0,MODE_HIGH,Length,i+Shift)] - Kv*iATR(NULL,0,ATRperiod,i+Shift); 
	     smax[i] =  Low[iLowest(NULL, 0,MODE_LOW, Length,i+Shift)] + Kv*iATR(NULL,0,ATRperiod,i+Shift);
	     Up[i]   = EMPTY_VALUE;
	     Dn[i]   = EMPTY_VALUE;
	     trend[i]=trend[i+1];
	     if (Close[i] > smax[i+1]) trend[i] =  1;
	     if (Close[i] < smin[i+1]) trend[i] = -1;
	     
	     //
	     //
	     //
	     //
	     //
	     
	     if (trend[i]>0) 
	     {
	       if(smin[i]<smin[i+1]) smin[i]=smin[i+1]; Up[i] = smin[i];
	  
	     }
	     if (trend[i]<0) 
	     {
	       if(smax[i]>smax[i+1]) smax[i]=smax[i+1]; Dn[i] = smax[i];
	     }
	
	}
	return(0);	
   }
   
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for (i=limit;i>=0; i--)
   {
       int y = iBarShift(NULL,timeFrame,Time[i]);
          Up[i]    = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Length,ATRperiod,Kv,Shift,0,y);
          Dn[i]    = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Length,ATRperiod,Kv,Shift,1,y);
          trend[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Length,ATRperiod,Kv,Shift,4,y);
   }
return(0);         
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}

